// PlaceLineImpl.cpp: implementation of the PlaceLineImpl class.
//
//////////////////////////////////////////////////////////////////////
//#define __NORECTANGLE__     /* so we can include windows.h */
#include <math.h>
#include <afxwin.h>
//#define __NORECTANGLE__

#include <cmdlist.h>
#include <toolsubs.h>
#include <string.h>

#include <msrsrc.fdf>
#include <msparse.fdf>
#include <msoutput.fdf>
#include <mselemen.fdf>
#include <msvar.fdf>
#include <msstate.fdf>
#include <mssystem.fdf>
#include <msdialog.fdf>

//#include "stdafx.h"
#include <msnativewindow.h>
#include "PlaceLineImpl.h"


extern "C" PlaceLineToolUI* PlaceLineToolUI_create (void);

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
PlaceLineImpl::PlaceLineImpl()
{
//open a dialog here?
AFX_MANAGE_STATE(AfxGetStaticModuleState());
oPlaceLineUI = PlaceLineToolUI_create();
}

PlaceLineImpl::~PlaceLineImpl()
{
AFX_MANAGE_STATE(AfxGetStaticModuleState());
oPlaceLineUI->MyClose ();
oPlaceLineUI = NULL;
}
	
//The external C interface most of these functions allow the callbacks in MicroStation to work.

extern "C"
    {
    PlaceLineImpl	*oPlaceLineImpl; 
	    
    __declspec (dllexport) void dataPoint (DPoint3d *pt, int view)
	    {
	    oPlaceLineImpl->dataPointHandle (pt,view);
	    }

    __declspec (dllexport) void dataPoint2 (DPoint3d *pt, int view)
	    {
	    oPlaceLineImpl->dataPoint2Handle (pt,view);
	    }

    __declspec (dllexport) void resetFunc ()
	    {
	    oPlaceLineImpl->resetHandle ();
	    }

    __declspec(dllexport) void	dynamicsFunc (DPoint3d *pt, int view)
	   {
	   oPlaceLineImpl->dynamicHandle (pt,view);
	   }

    __declspec(dllexport) void 	PlaceLineTool_start( void )
	    {
	    oPlaceLineImpl = new PlaceLineImpl();
	    mdlState_startPrimitive (dataPoint,resetFunc,0,0);
	    return;
	    }

    }
//The Object code  
void	PlaceLineImpl::dataPoint2Handle (DPoint3d *pt,int   view)
    {
    MSElement	el;
    DPoint3d	pts[2];
    pts[0] = this->startPoint;
    pts[1] = *pt;

    mdlLine_create (&el,NULL,pts);
    setSymbology (&el);
    mdlElement_display (&el,NORMALDRAW);
    mdlElement_add (&el);
    startPoint= *pt;
    }
void	PlaceLineImpl::dataPointHandle (DPoint3d    *pt,int view)
    {
    startPoint = *pt;
    mdlState_setFunction (STATE_DATAPOINT, dataPoint2 );
    mdlState_dynamicUpdate (dynamicsFunc,FALSE);
    }
void	PlaceLineImpl::resetHandle ()
    {
    mdlState_startDefaultCommand ();
    delete (this);
    }
void	PlaceLineImpl::dynamicHandle (DPoint3d	*pt, int view)
    {
    DPoint3d	pts[2];
    pts[0] = this->startPoint;
    pts[1] = *pt;
    mdlLine_create (dgnBuf, NULL, pts);
    setSymbology (dgnBuf);
    }

void	PlaceLineImpl::setSymbology (MSElement *el)
    {
    ULong	color = oPlaceLineUI->getColor();//PlaceLineUI_getColor (pDlg);
    ULong	weight = oPlaceLineUI->getWeight();//(pDlg);
    long	style = oPlaceLineUI->getStyle(); //(pDlg);
    mdlElement_setSymbology (el,&color,&weight,&style);
    }