//
// This file was generated by the Bentley MFC Application Wizard
//
///////////////////////////////////////////////////////////////////////////////

#include <cmdlist.h>
#include <toolsubs.h>
#include <string.h>

#include <msrsrc.fdf>
#include <msparse.fdf>
#include <msoutput.fdf>
#include <mselemen.fdf>
#include <msvar.fdf>
#include <msstate.fdf>
#include <mssystem.fdf>
#include <msdialog.fdf>

#include <msnativewindow.h>

#include "PlaceLineTool.h"
#include "PlaceLineToolcmd.h"

void	*pTS;
    
    
extern "C"    void *PlaceLineToolMfc_OpenToolSettingsContent( void );
extern "C"    int PlaceLineToolMfc_CloseToolSettingsContent( void * );
extern "C"    char const * PlaceLineToolMfc_GetEditBoxText( void * );
extern "C"	void PlaceLineTool_start (void);

/*---------------------------------------------------------------------------------**//**
* @description  PlaceLineTool_mdlDialogHook
* @param 	dmP      The DialogMessage 
* @bsimethod 							BSI             06/03
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" Public void	PlaceLineTool_mdlDialogHook
(
DialogMessage   *dmP
)
    {

    dmP->msgUnderstood = TRUE;
    switch (dmP->messageType)
	{
	case DIALOG_MESSAGE_CREATE:
	    {
	    dmP->u.create.interests.windowMoving= TRUE;
	    dmP->u.create.interests.resizes     = TRUE;
	    dmP->u.create.interests.updates     = TRUE;
	    dmP->u.create.interests.dialogFocuses = TRUE;

	    // initialize Globals
	    
	    break;
	    }
	case DIALOG_MESSAGE_WINDOWMOVING:
	    {
	    dmP->u.windowMoving.handled = FALSE;

            /* Don't process if only moving dialog box */
            if (dmP->u.windowMoving.whichCorners == CORNER_ALL ||
	    	dmP->u.windowMoving.whichCorners == CORNER_ALL_RESIZED)
                break;
		    
	    dmP->u.windowMoving.handled = TRUE;

	    break;
	    }
	case DIALOG_MESSAGE_INIT:
	    {
	    
	    /* Fall through */
	    }
	case DIALOG_MESSAGE_UPDATE:
	    {
		
	    // resize items

	    break;
	    }

	case DIALOG_MESSAGE_RESIZE:
	    {
            /* Don't process if only moving dialog box */
            if (dmP->u.resize.whichCorners == CORNER_ALL)
                break;
	       
	    dmP->u.resize.forceCompleteRedraw = TRUE;
		
	    break;
	    }

	case DIALOG_MESSAGE_FOCUSIN:
	    {
	    break;
	    }

	case DIALOG_MESSAGE_DESTROY:
	    {
	    // save globals
	    break;
	    }

	default:
	    dmP->msgUnderstood = FALSE;
	    break;
	}
    }
/*======================================================================+
|                                                                       |
|   Place Date State and Dynamics Functions				|
|                                                                       |
+======================================================================*/
/*----------------------------------------------------------------------+*//**
* Creates the text element	    
* @bsimethod createText   				
* @param 	pntP     Data point to create the text	
* @param 	view     view to create the text	
* @param 	elP     The element to create	    	
* @return 	SUCCESS 			    	
*							
* Author:   BSI 				06/03 	
*							
+----------------------------------------------------------------------*/
MdlPublic  int createText
(
Dpoint3d    *pntP, /*Data point to create the text*/
int         view,  /*view to create the text*/
MSElement   *elP   /*The element to create*/
)
    {

    char  * str = strdup(PlaceLineToolMfc_GetEditBoxText(pTS));

    /* Temporarily create the text element in the element passed in */
    mdlText_create (elP, NULL, str, NULL, NULL, NULL, NULL, NULL);
    mdlElement_offset (elP, elP, pntP);

	free(str);

    return SUCCESS;
    }

/*----------------------------------------------------------------------+*//**
* acts as a layer betweeen the createText and the calling functions for dynamics    
* @bsimethod generateText   					
* @param 	pntP     Data point to create the text	
* @param 	view     view to create the text	
*								
* Author:   BSI 				06/03 		
*								
+----------------------------------------------------------------------*/
Public  void generateText
(
DPoint3d        *pntP, /*Data point to create the text*/
int             view   /*view to create the text*/
)
    {
    createText (pntP, view, dgnBuf);
    }

/*----------------------------------------------------------------------+*//**
* 							      
* @bsimethod placeDate_done   				      
*							      
* Author:   BSI 				06/03 	      
*							      
+----------------------------------------------------------------------*/
Public  void placeDate_done
(
void
)
    {
    /*-----------------------------------------------------------------
    | Start the default command, after you have placed the text element
    | for the date stamp.  This is a single shot tool.
    +-----------------------------------------------------------------*/
    mdlState_startDefaultCommand ();
    }

/*----------------------------------------------------------------------+*//**
* 							      
* @bsimethod placeDate_atPoint   			      
* @param 	pntP     Data point to create the text	
*							      
* Author:   BSI 				06/03 	      
*							      
+----------------------------------------------------------------------*/
Public  void placeDate_atPoint
(
Dpoint3d        *pntP
)
    {
    MSElement   el;

    /*-----------------------------------------------------------------
    | As the location for our date stamp can be specified by a single
    | datapoint use the dynamics function to create our text element
    | in dgnBuf at it's final location.
    +-----------------------------------------------------------------*/
    createText (pntP, tcb->lstvw, &el);

    /* Display the new text element and add it to the design file */
    mdlElement_display (&el, NORMALDRAW);
    mdlElement_add (&el);

    /* Call our cleanup function terminating the primitive command */
    placeDate_done ();
    }

/*----------------------------------------------------------------------+*//**
* 							      
* @bsimethod placeDate_start   				      
* @param 	unparsedP     Contination string that started this command
*							      
* Author:   BSI 				06/03 	      
*							      
+----------------------------------------------------------------------*/
void placeDate_start
(
char            *unparsedP
)
    {

    mdlState_startPrimitive (placeDate_atPoint, placeDate_done, 
			    COMMANDID_PlaceDate, PROMPTID_EnterPoint);

    /*-----------------------------------------------------------------
    | Start dynamics to display elements when one more datapoint will 
    | give enough information to write an element to the design file.
    | For our text element, we can start dynamics right away.
    +-----------------------------------------------------------------*/
    mdlState_dynamicUpdate (generateText, TRUE);

    }
/*---------------------------------------------------------------------------------**//**
* @description  Function called when cleaning up the command
* @param 	bEnteringViewCmd TRUE if entering a view command
* @bsimethod 							BSI             06/03
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" Public int PlaceLineTool_ToolSettingsCleanup
(
void
)
    {
    PlaceLineToolMfc_CloseToolSettingsContent(pTS);
    
    return  SUCCESS;
    }
    
/*---------------------------------------------------------------------------------**//**
* @description  Function called when resetting out of a command
* @param 	bEnteringViewCmd TRUE if entering a view command
* @bsimethod 							BSI             06/03
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" Public int PlaceLineTool_ToolSettingsReset
(
void
)
    {
    mdlState_startDefaultCommand ();
    
    return  SUCCESS;
    }
    
    

/*---------------------------------------------------------------------------------**//**
* @description  PlaceLineTool_runToolSettingsDialog
* @param 	unparsed
* @bsimethod 							BSI             06/03
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" Public void PlaceLineTool_runToolSettingsDialog
(
char            *unparsed
)
    {
    
    // TODO: start your primitive here
    placeDate_start(unparsed);

    mdlState_setFunction (STATE_RESET, PlaceLineTool_ToolSettingsReset);
    mdlState_setFunction (STATE_COMMAND_CLEANUP, PlaceLineTool_ToolSettingsCleanup);
    
    pTS = PlaceLineToolMfc_OpenToolSettingsContent();
    }
/*---------------------------------------------------------------------------------**//**
* @description  PlaceLineTool_openMainDialog
* @param 	unparsed
* @bsimethod 							BSI             06/03
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" Public void PlaceLineTool_openMainDialog
(
char            *unparsed
)
    {
    DialogBox   *dbP;

    if (NULL != (dbP=mdlDialog_find (DIALOGID_MDLDialog,NULL)))
        mdlDialog_show (dbP);
    else
        mdlDialog_open (NULL, DIALOGID_MDLDialog);
    }
/*---------------------------------------------------------------------------------**//**
* @description  PlaceLineTool_unloadFunction                                                 
* @param 	unloadType      Reason for the unload of the app        	
* @return 	SUCCESS to allow the unload; ERROR to disallow the unload
* @bsimethod 							BSI             06/03
+---------------+---------------+---------------+---------------+---------------+------*/
Private int     PlaceLineTool_unloadFunction
(
int     unloadType
)
    {
    BoolInt     disallow = FALSE;

    /*------------------------------------------------------------------
    |   If the value of unloadType is negative, then MicroStation ignores
    |   the return value of this function.  In this case, we can assume
    |   that MicroStation is shutting down or was terminated so this
    |   function should not attempt to abort the unload.
    +------------------------------------------------------------------*/
    if (unloadType < 0)
        {
        return FALSE;
        }
	
    /* 
    ** Your processing, which may include setting the disallow flag to TRUE 
    */
    
    return  (disallow ? ERROR : SUCCESS);
    }

    
/*---------------------------------------------------------------------------------**//**
* Dialog/Item Hooks; Command Numbers and Command Names
+---------------+---------------+---------------+---------------+---------------+------*/

typedef void (*Handler)(char *);
typedef void (*Hook)();

Private DialogHookInfo uHooks[] =
    {
    {HOOKDIALOGID_MDLDialog, (Hook) PlaceLineTool_mdlDialogHook},
    };

Private MdlCommandNumber commandNumber[] = 
    {
	{(Handler) PlaceLineTool_openMainDialog,	CMD_PLACELINETOOL_DIALOG_OPEN},
	{(Handler) PlaceLineTool_runToolSettingsDialog,	CMD_PLACELINETOOL_RUN_TOOLSETTINGSDIALOG},
	{(Handler) PlaceLineTool_start,	CMD_PLACELINETOOL_PLACE_MFCLINE},
	0
    };


/*---------------------------------------------------------------------------------**//**
* @description  MdlMain                                                 
* @param 	argc     Count of arguments into the function        	
* @param 	argv     Array of arguments                             
* @return 	Return code from the application                        
*                                                                       
* @bsimethod 							BSI             06/03
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" DLLEXPORT  int MdlMain
(
int         argc,
char        *argv[]
)
    {
    RscFileHandle   rscFileH;

    /*-----------------------------------------------------------------------
    mdlResource_openFile:

    This function opens a resource file, thus making its contents
    available to the application.  In this case, we need to open
    treexmpl.ma as a resource file so that we have access to the the
    string lists for our messages.
    -----------------------------------------------------------------------*/
    if (SUCCESS	!= mdlResource_openFile	(&rscFileH, NULL, 0))
	{
	mdlOutput_rscPrintf (MSG_ERROR,	0l, MESSAGELISTID_Messages,
			     MESSAGEID_ResourceLoadError);

	/* unload the application */
	mdlDialog_cmdNumberQueue (FALSE, CMD_MDL_UNLOAD,
				  mdlSystem_getCurrTaskID (), TRUE);
	}

    /* --- Set up function to get called at unload time --- */
    mdlSystem_setFunction (SYSTEM_UNLOAD_PROGRAM,   PlaceLineTool_unloadFunction);
    mdlSystem_registerCommandNumbers (commandNumber);
    mdlState_registerStringIds (MESSAGELISTID_Commands,      MESSAGELISTID_Commands);
    mdlDialog_hookPublish (sizeof uHooks/sizeof uHooks[0],uHooks);
    mdlParse_loadCommandTable (NULL);
    
    return 0;
    }

